## libstorj 1.0.2

=== depends/Makefile ===
.NOTPARALLEL :

build_DOWNLOAD = curl --location --fail --connect-timeout 120 --retry 3 -o

BUILD = $(shell ./config.guess)
HOST ?= $(BUILD)

DOWNLOAD_DIR = "$(CURDIR)/downloads/"
SOURCES_DIR = "$(CURDIR)/sources/$(HOST)/"
PREFIX_DIR = "$(CURDIR)/build/$(HOST)/"
TOOLCHAIN_BUILD_DIR = "$(CURDIR)/toolchain/build/"
TOOLCHAIN_SOURCE_DIR = "$(CURDIR)/toolchain/source/"

canonical_host:=$(shell ./config.sub $(HOST))

host_arch=$(firstword $(subst -, ,$(canonical_host)))
host_vendor=$(word 2,$(subst -, ,$(canonical_host)))
full_host_os:=$(subst $(host_arch)-$(host_vendor)-,,$(canonical_host))
host_os:=$(findstring linux,$(full_host_os))
host_os+=$(findstring darwin,$(full_host_os))
host_os+=$(findstring mingw32,$(full_host_os))
host_os:=$(strip $(host_os))
ifeq ($(host_os),)
host_os=$(full_host_os)
endif

# mac build
DARWIN_SDK_PATH ?= "$(CURDIR)/MacOSX10.11.sdk"
DARWIN_CFLAGS = "-target $(HOST) -isysroot $(DARWIN_SDK_PATH) -mmacosx-version-min=10.8 -mlinker-version=253.9 -pipe -I$(PREFIX_DIR)include"
DARWIN_LDFLAGS="-L$(TOOLCHAIN_BUILD_DIR)lib -L$(DARWIN_SDK_PATH)/usr/lib -L$(PREFIX_DIR)lib -Wl,-syslibroot $(DARWIN_SDK_PATH)"

build_SHA256SUM = sha256sum -c

build_env=
ifeq ($(host_os), darwin)
build_env=PATH="$(TOOLCHAIN_BUILD_DIR)bin:${PATH}" CC=clang CXX=clang++ CFLAGS=$(DARWIN_CFLAGS) LDFLAGS=$(DARWIN_LDFLAGS)
endif
ifeq ($(HOST), i686-pc-linux-gnu)
build_env=CFLAGS=-m32 CXXFLAGS=-m32 LDFLAGS=-m32
endif

toolchain_packages:=clang cctools
packages:=gmp nettle gnutls libcurl json-c libuv libmicrohttpd
all_packages = $(toolchain_packages) $(packages)

$(foreach package,$(all_packages),$(eval include packages/$(package).mk))

define fetch_file
	set -e && \
	mkdir -p "$(DOWNLOAD_DIR)" && \
	cd "$(DOWNLOAD_DIR)" && \
	if test -f "$($(1)_file_name)"; then \
	echo "Skipping download: $($(1)_download_path)"; \
	else \
	echo "Downloading: $($(1)_download_path)"; \
	$(build_DOWNLOAD) "$($(1)_file_name)" "$($(1)_download_path)"; \
	echo "$($(1)_sha256_hash)\t$($(1)_file_name)" > "$($(1)_file_name)".hash; \
	$(build_SHA256SUM) "$($(1)_file_name)".hash; \
	fi && \
	cd "$(CURDIR)"
endef

define extract_file
	set -e && \
	if test -d "$(SOURCES_DIR)$(1)"; then \
	echo "Skipping extract: $(DOWNLOAD_DIR)$($(1)_file_name)"; \
	else \
	echo "Extracting: $(DOWNLOAD_DIR)$($(1)_file_name)"; \
	mkdir -p "$(SOURCES_DIR)$(1)"; \
	tar xf "$(DOWNLOAD_DIR)$($(1)_file_name)" -C "$(SOURCES_DIR)$(1)" --strip-components=1; \
	fi
endef

define build_source
	echo "\n\nBuilding $(1)\n====================================" && \
	cd "$(SOURCES_DIR)$(1)" && \
	echo "curdir: $(CURDIR)" && \
	echo "build_env: $(build_env)" && \
	echo "config_env: $($(1)_config_env)" && \
	echo "config_opts: $($(1)_config_opts)" && \
	echo "host: $(HOST)" && \
	echo "prefix: $(PREFIX_DIR)" && \
	echo "====================================\n\n" && \
	export PATH="$(TOOLCHAIN_BUILD_DIR)bin:${PATH}" && \
	if test -f "./autogen.sh"; then ./autogen.sh; fi && \
	$(build_env) $($(1)_config_env) ./configure --host="$(HOST)" $($(1)_config_opts) --enable-static --disable-shared --prefix=$(PREFIX_DIR) || exit && \
	make || exit && \
	make install || exit && \
	cd "$(CURDIR)"
endef

define extract_toolchain_file
	if test -d "$(TOOLCHAIN_SOURCE_DIR)$(1)"; then \
	echo "Skipping extract: $(DOWNLOAD_DIR)$($(1)_file_name)"; \
	else \
	echo "Extracting: $(DOWNLOAD_DIR)$($(1)_file_name)"; \
	mkdir -p "$(TOOLCHAIN_SOURCE_DIR)$(1)"; \
	tar xf "$(DOWNLOAD_DIR)$($(1)_file_name)" -C "$(TOOLCHAIN_SOURCE_DIR)$(1)" --strip-components=1; \
	fi
endef

define extract_toolchain_file_build
	mkdir -p "$(TOOLCHAIN_BUILD_DIR)"; \
	tar xfv "$(DOWNLOAD_DIR)$($(1)_file_name)" -C "$(TOOLCHAIN_BUILD_DIR)" --strip-components=1; \
	rm -f $(TOOLCHAIN_BUILD_DIR)lib/libc++abi.so
endef

ifeq ($(host_os), darwin)
define build_darwin_toolchain
	echo "Building darwin toolchain" && \
	$(foreach package,$(toolchain_packages),$(call fetch_file,$(package));)
	$(foreach package,clang,$(call extract_toolchain_file_build,$(package));)
	$(foreach package,cctools,$(call extract_toolchain_file,$(package));)
	cd "$(TOOLCHAIN_SOURCE_DIR)cctools/cctools" && \
	if test -f "./autogen.sh"; then ./autogen.sh; fi && \
	PATH="$(TOOLCHAIN_BUILD_DIR)bin:${PATH}" CC=clang CXX=clang++ ./configure --prefix="$(TOOLCHAIN_BUILD_DIR)" --target="x86_64-apple-darwin11" || exit && \
	make || exit && \
	make install || exit && \
	cd "$(CURDIR)"
endef
else
define build_darwin_toolchain
	echo "Skipping building darwin toolchain"
endef
endif

build-sources: extract-sources
	@$(foreach package,$(packages),$(call build_source,$(package));)

extract-sources: download-sources
	@$(foreach package,$(packages),$(call extract_file,$(package));)

download-sources: build-toolchain
	@$(foreach package,$(packages),$(call fetch_file,$(package));)

build-toolchain:
	@$(call build_darwin_toolchain,)

clean:
	$(RM) -rv $(DOWNLOAD_DIR)
	$(RM) -rv $(SOURCES_DIR)
	$(RM) -rv $(PREFIX_DIR)

.PHONY: extract-sources

=== debian/changelog ===
libstorj (1.0.2-1) unstable; urgency=low

  * Initial release. (Closes: #869130)

 -- Josue Ortega <josue@debian.org>  Wed, 30 Aug 2017 19:42:56 -0600

=== debian/control ===
Source: libstorj
Section: libs
Priority: optional
Maintainer: Josue Ortega <josue@debian.org>
Build-Depends: debhelper (>=9),
 autotools-dev,
 pkg-config,
 libmicrohttpd-dev,
 bsdmainutils,
 libcurl4-gnutls-dev,
 nettle-dev,
 libjson-c-dev,
 libuv1-dev
Standards-Version: 4.0.1
Homepage: https://github.com/Storj/libstorj
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libstorj.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libstorj.git

Package: libstorj0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Asynchronous C library for file transfer on the Storj network
 Asynchronous multi-platform C library for encrypted file transfer on  the Storj
 network.
 libstorj provides the following features:
  - Asynchronous I/O with concurrent peer-to-peer network requests for shards
  - Erasure encoding with reed solomon for data durability
  - Robust handling of shard transfers by selecting alternative sources
  - File integrity and authenticity verified with HMAC-SHA512
  - File encryption with AES-256-CTR
  - File name and bucket name encryption with AES-256-GCM
  - Proxy support with SOCKS5, SOCKS4, SOCKS4a
  - Asynchronous progress updates in bytes per file
  - Transfers can be cleanly canceled per file
  - Seed based file encryption key for portability between devices
  - Reference implementation for SIP5 file standard

Package: libstorj-dev
Section: libdevel
Provides: libstorj-dev
Conflicts: libstorj-dev
Architecture: any
Depends: ${misc:Depends},
 libstorj0  (= ${binary:Version}),
 libmicrohttpd-dev,
 libcurl4-gnutls-dev,
 nettle-dev,
 libjson-c-dev,
 libuv1-dev
Description: C library for file transfer on Storj network (Development files)
 Asynchronous multi-platform C library for encrypted file transfer on  the Storj
 network.
 libstorj provides the following features:
  - Asynchronous I/O with concurrent peer-to-peer network requests for shards
  - Erasure encoding with reed solomon for data durability
  - Robust handling of shard transfers by selecting alternative sources
  - File integrity and authenticity verified with HMAC-SHA512
  - File encryption with AES-256-CTR
  - File name and bucket name encryption with AES -256 -GCM
  - Proxy support with SOCKS5, SOCKS4, SOCKS4a
  - Asynchronous progress updates in bytes per file
  - Transfers can be cleanly canceled per file
  - Seed based file encryption key for portability between devices
  - Reference implementation for SIP5 file standard
 .
 This package contains the development files for libjstorj.

Package: storj
Section: net
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 libstorj0 (= ${binary:Version})
Description: Command Line Tool for encrypted file transfer on the Storj network
 CLI Tool for file transfer on the Storj network, it provides an interface for
 setting up users profiles, work with buckets and files, download and
 upload files and get information from the Storj API.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with autotools-dev

override_dh_auto_configure:
	$(CURDIR)/autogen.sh
	./configure --prefix=/usr
	#dh_auto_configure

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(CURDIR)/Makefile.in
	rm -f $(CURDIR)/aclocal.m4
	rm -f $(CURDIR)/configure
	rm -f $(CURDIR)/src/Makefile.in
	rm -f $(CURDIR)/test/Makefile.in
	rm -rf $(CURDIR)/build-aux

override_dh_auto_install:
	dh_auto_install
	#Removes non-empty dependency_libs at .la files
	sed -i "/dependency_libs/ s/'.*'/''/" `find . -name '*.la'`

override_dh_auto_test:
	#Disable tests

## libstorj 1.0.3

=== depends/Makefile ===
--- 
+++ 
@@ -27,13 +27,14 @@
 # mac build
 DARWIN_SDK_PATH ?= "$(CURDIR)/MacOSX10.11.sdk"
 DARWIN_CFLAGS = "-target $(HOST) -isysroot $(DARWIN_SDK_PATH) -mmacosx-version-min=10.8 -mlinker-version=253.9 -pipe -I$(PREFIX_DIR)include"
+DARWIN_CXXFLAGS = "-target $(HOST) -isysroot $(DARWIN_SDK_PATH) -mmacosx-version-min=10.8 -mlinker-version=253.9 -pipe -I$(PREFIX_DIR)include"
 DARWIN_LDFLAGS="-L$(TOOLCHAIN_BUILD_DIR)lib -L$(DARWIN_SDK_PATH)/usr/lib -L$(PREFIX_DIR)lib -Wl,-syslibroot $(DARWIN_SDK_PATH)"
 
 build_SHA256SUM = sha256sum -c
 
 build_env=
 ifeq ($(host_os), darwin)
-build_env=PATH="$(TOOLCHAIN_BUILD_DIR)bin:${PATH}" CC=clang CXX=clang++ CFLAGS=$(DARWIN_CFLAGS) LDFLAGS=$(DARWIN_LDFLAGS)
+build_env=PATH="$(TOOLCHAIN_BUILD_DIR)bin:${PATH}" CC=clang CXX=clang++ CFLAGS=$(DARWIN_CFLAGS) CXXFLAGS=$(DARWIN_CXXFLAGS) LDFLAGS=$(DARWIN_LDFLAGS)
 endif
 ifeq ($(HOST), i686-pc-linux-gnu)
 build_env=CFLAGS=-m32 CXXFLAGS=-m32 LDFLAGS=-m32
@@ -101,8 +102,7 @@
 
 define extract_toolchain_file_build
 	mkdir -p "$(TOOLCHAIN_BUILD_DIR)"; \
-	tar xfv "$(DOWNLOAD_DIR)$($(1)_file_name)" -C "$(TOOLCHAIN_BUILD_DIR)" --strip-components=1; \
-	rm -f $(TOOLCHAIN_BUILD_DIR)lib/libc++abi.so
+	tar xfv "$(DOWNLOAD_DIR)$($(1)_file_name)" -C "$(TOOLCHAIN_BUILD_DIR)" --strip-components=1
 endef
 
 ifeq ($(host_os), darwin)
@@ -113,7 +113,7 @@
 	$(foreach package,cctools,$(call extract_toolchain_file,$(package));)
 	cd "$(TOOLCHAIN_SOURCE_DIR)cctools/cctools" && \
 	if test -f "./autogen.sh"; then ./autogen.sh; fi && \
-	PATH="$(TOOLCHAIN_BUILD_DIR)bin:${PATH}" CC=clang CXX=clang++ ./configure --prefix="$(TOOLCHAIN_BUILD_DIR)" --target="x86_64-apple-darwin11" || exit && \
+	./configure --prefix="$(TOOLCHAIN_BUILD_DIR)" --target="x86_64-apple-darwin11" || exit && \
 	make || exit && \
 	make install || exit && \
 	cd "$(CURDIR)"

=== debian/changelog ===
libstorj (1.0.3-1build2) focal; urgency=medium

  * No-change rebuild against libnettle7

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 31 Oct 2019 22:12:18 +0000

libstorj (1.0.3-1build1) eoan; urgency=medium

  * Rebuild against new libjson-c4.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 29 Jun 2019 13:55:15 +0200

libstorj (1.0.3-1) unstable; urgency=medium

  * New upstream release (1.0.3).
  * Bump debhelper compat level to 11:
    - Remove autotools-dev from build-dependencies.
  * debian/rules: Remove call of debhelper tools from autotools-dev.
  * debian/control: Change Vcs-* fields to use salsa.debian.org.
  * Bumps Standards-Version to 4.3.0:
    - debian/control: Add Rules-Requires-Root field.
  * Add Build-Depends-Pacakge field to libstorj0 symbols file

 -- Josue Ortega <josue@debian.org>  Sun, 30 Dec 2018 11:48:58 -0600

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: libstorj
 Section: libs
 Priority: optional
-Maintainer: Josue Ortega <josue@debian.org>
-Build-Depends: debhelper (>=9),
- autotools-dev,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Josue Ortega <josue@debian.org>
+Build-Depends: debhelper (>=11),
  pkg-config,
  libmicrohttpd-dev,
  bsdmainutils,
@@ -11,10 +11,11 @@
  nettle-dev,
  libjson-c-dev,
  libuv1-dev
-Standards-Version: 4.0.1
+Standards-Version: 4.3.0
+Rules-Requires-Root: no
 Homepage: https://github.com/Storj/libstorj
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/libstorj.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libstorj.git
+Vcs-Git: https://salsa.debian.org/debian/libstorj.git
+Vcs-Browser: https://salsa.debian.org/debian/libstorj
 
 Package: libstorj0
 Architecture: any

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libstorj-$1\.tar\.gz/ \
  https://github.com/Storj/libstorj/tags .*/v*(\d\S*)\.tar\.gz
